/*************************************************************

(C) ISEP 2004
(C) Professores de ADAV 2004

O ISEP, na qualidade de autor do presente software, garante 
o direito de utilizao, alterao, evoluo e distribuio 
do mesmo sem qualquer tipo de restries, excepto:
	- esta mensagem no pode ser retirada
	- os nomes das classes no podem ser alterados

*************************************************************/

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;

using ShopClassLibrary;

namespace AdavShop
{
	/// <summary>
	/// Summary description for Catalog.
	/// </summary>
	public class Catalog : System.Web.Services.WebService
	{
		public Catalog()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		// WEB SERVICE EXAMPLE
		// The HelloWorld() example service returns the string Hello World
		// To build, uncomment the following lines then save and build the project
		// To test this web service, press F5

//		[WebMethod]
//		public string HelloWorld()
//		{
//			return "Hello World";
//		}

		#region IProductWeb

		//
		// estrutra criada para mostrar como se pode retornar tipos proprios de um web service
		// adicionalmente serve para usar a pgina de teste criada automaticamnete pelo asp.net
		// j que os parametros de output e tipos de dados no primitivos s funcionam via programao
		//
		public struct GetCatalogEnvelope
		{
			public ShopStatusEnum status;
			public DataSet catalog;
		}

		[WebMethod]
		public GetCatalogEnvelope GetCatalog(string customerUserName, string customerPassword)
		{
			GetCatalogEnvelope ret = new GetCatalogEnvelope();

			IProductWeb comp = new Product();
			DataSet ds = comp.GetCatalog(customerUserName, customerPassword, out ret.status);
			ret.catalog = ds;

			return ret;
		}

		//
		// embora o C# suporte overloading (o memso nome de mtodo com parametros diferentes)
		// o SOAP no suporta. cada mensagem deve ter um nome nico.
		// o atributo MessageName permite indicar o nome da mensagem SOAP correspondente a este 
		// mtodo, e dessa forma dessambiguar o nome GetCatalog
		//
		[WebMethod(MessageName = "GetCatalogAPI")]
		public DataSet GetCatalog(string customerUserName, string customerPassword, out ShopStatusEnum status)
		{
			IProductWeb comp = new Product();
			return comp.GetCatalog(customerUserName, customerPassword, out status);
		}

		#endregion
	}
}
