/*************************************************************

(C) ISEP 2004
(C) Professores de ADAV 2004

O ISEP, na qualidade de autor do presente software, garante 
o direito de utilizao, alterao, evoluo e distribuio 
do mesmo sem qualquer tipo de restries, excepto:
	- esta mensagem no pode ser retirada
	- os nomes das classes no podem ser alterados

*************************************************************/

using System;

namespace ShopClassLibrary
{
	/// <summary>
	/// cdigo de sucesso ou insucesso de uma operao no componente.
	/// 
	/// NOTA: 
	/// nesta verso foi alterada a nomenclatura dos valores possiveis, quebrando assim
	/// o principio de imutabilidade de interfaces. esta deciso foi tomada no sentido de 
	/// obedecer s regras de nomenclatura de tipos do .net
	/// com esta alterao existe o risco de aplicaes clientes j existentes deixarem de 
	/// funcionar. em situaes reais, esta deciso deve ser MUITO BEM ponderada. 
	/// </summary>
	public enum ShopStatusEnum 
	{
		Ok,					// success
		NotOk,				// insuccess
		InvalidLogin,		// invalid login pair username/password
		InvalidKey,			//
		InvalidCustomerID,	// invalid customer id provided
		InvalidProductID,	// invalid product id provided
		InsuficientStock,	// insuficient stock of product to complete the operation
		Error,				// general internal error
		InvalidArgument,	// invalid arguement passed to a function
		DatabaseError,		// general databse error
		NotSupported		// not supported (implemented) operation
	}

}
