/*************************************************************

(C) ISEP 2004
(C) Professores de ADAV 2004

O ISEP, na qualidade de autor do presente software, garante 
o direito de utilizao, alterao, evoluo e distribuio 
do mesmo sem qualquer tipo de restries, excepto:
	- esta mensagem no pode ser retirada
	- os nomes das classes no podem ser alterados

*************************************************************/

using System;
using System.Data;
using System.Data.Common;
using System.Data.OleDb;

namespace ShopClassLibrary
{
	/// <summary>
	/// Summary description for Comum.
	/// </summary>
	internal class UtilDB
	{
		private const string DEFAULT_CONN = @"Provider=Microsoft.Jet.OLEDB.4.0;User ID=;Password=;Mode=Share Deny None;Data Source=";
		private const string DEFAULT_DBPATH = @"c:\temp\Sales.mdb"; //@"C:\Documents and Settings\Paulo Sousa\My Documents\Actividade Lectiva\Disciplinas\ADAV\trab ref 2004-2005\ShopPAG\Sales.mdb";

		public static string CONN
		{
			get { return DEFAULT_CONN + DEFAULT_DBPATH; }
		}

		public UtilDB()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		#region ValidateUser

		/// <summary>
		/// Valida um login/password no sistema
		/// </summary>
		/// <param name="User">username de login na aplicao</param>
		/// <param name="Pass">password de login na aplicao</param>
		/// <returns></returns>
		static public ShopStatusEnum ValidateUser(string user, string pass)
		{
			int userID;
			return ValidateLogin(user, pass, false, out userID);
		}

		/// <summary>
		/// Valida um login/password no sistema
		/// </summary>
		/// <param name="User">username de login na aplicao</param>
		/// <param name="Pass">password de login na aplicao</param>
		/// <returns></returns>
		static public ShopStatusEnum ValidateUser(OleDbConnection conn, OleDbTransaction tx, string user, string pass)
		{
			int userID;
			return ValidateLogin(conn, tx, user, pass, false, out userID);
		}
		#endregion

		#region ValidateCustomerLogin
		
		/// <summary>
		/// Valida um login/password no sistema
		/// </summary>
		/// <param name="User">username de login na aplicao</param>
		/// <param name="Pass">password de login na aplicao</param>
		/// <returns></returns>
		static public ShopStatusEnum ValidateCustomerLogin(string user, string pass, out int customerID)
		{
			return ValidateLogin(user, pass, true, out customerID);
		}

		/// <summary>
		/// Valida um login/password no sistema
		/// </summary>
		/// <param name="User">username de login na aplicao</param>
		/// <param name="Pass">password de login na aplicao</param>
		/// <returns></returns>
		static public ShopStatusEnum ValidateCustomerLogin(OleDbConnection conn, OleDbTransaction tx, string user, string pass, out int customerID)
		{
			return ValidateLogin(conn, tx, user, pass, true, out customerID);
		}

		#endregion

		#region GetByID

		/// <summary>
		/// Obtem um dataset resultante de uma pesquisa por chave
		/// </summary>
		/// <param name="table">tabela a pesquisar</param>
		/// <param name="field">campo chave a usar</param>
		/// <param name="key">valor da chave a pesquisar</param>
		/// <returns>um dataset do tipo pedido</returns>
//		static public DataSet GetByID(string table, string keyName, long key)
//		{
//			DataSet ds = null;
//			OleDbConnection conn = null;
//
//			try
//			{				
//				//
//				// criar objecto DataSet
//				//
//				ds = new DataSet();
//
//				//
//				// criar objecto de conexo  base de dados e abrir a conexo
//				//
//				conn = new OleDbConnection(CONN);
//				conn.Open();
//
//				//
//				// criar um Datadapter para executar o comando e devolver o dataset
//				//
//				string sSqlCmd = "Select * From "+ table + " Where "+ keyName + " = "+ key.ToString();
//				OleDbDataAdapter oAdapter = new OleDbDataAdapter(sSqlCmd, conn);
//
//				//
//				// executar o comando e preencher um Dataset
//				//
//				oAdapter.Fill(ds, table);
//			}
//			catch(OleDbException ex)
//			{
//				//
//				// tratar a excepo!!!!
//				//
//				System.Console.WriteLine("EXCEPO no mtodo 'UtilDB.GetByID': " + ex.Message);
//				//status = ShopStatusEnum.DatabaseError;
//				ds = null;
//			}
//			finally
//			{
//				//
//				// fechar a conexo
//				//
//				if (conn.State == ConnectionState.Open)
//					conn.Close();
//			}
//
//			return ds;
//		}

		/// <summary>
		/// Obtem um dataset resultante de uma pesquisa por chave
		/// </summary>
		/// <param name="conn">a conexo a utilizar</param>
		/// <param name="table">tabela a pesquisar</param>
		/// <param name="keyName">campo chave a usar</param>
		/// <param name="key">valor da chave a pesquisar</param>
		/// <returns>um dataset do tipo pedido</returns>
		static public DataSet GetByID(OleDbConnection conn, OleDbTransaction tx, string table, string keyName, long key, out ShopStatusEnum status)
		{
			DataSet ds = null;

			status = ShopStatusEnum.Ok;

			try
			{				
				//
				// criar objecto DataSet
				//
				ds = new DataSet();

				//
				// criar um Datadapter para executar o comando e devolver o dataset
				//
				string sSqlCmd = "Select * From "+ table + " Where "+ keyName + " = "+ key.ToString();
				OleDbDataAdapter oAdapter = new OleDbDataAdapter(sSqlCmd, conn);
				oAdapter.SelectCommand.Transaction = tx;

				//
				// executar o comando e preencher um Dataset
				//
				oAdapter.Fill(ds, table);
			}
			catch(OleDbException ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO no mtodo 'UtilDB.GetByID': " + ex.Message);
				status = ShopStatusEnum.DatabaseError;
				ds = null;
			}

			return ds;
		}

		/// <summary>
		/// Obtem um dataset resultante de uma pesquisa por chave
		/// </summary>
		/// <param name="table">tabela a pesquisar</param>
		/// <param name="field">campo chave a usar</param>
		/// <param name="key">valor da chave a pesquisar</param>
		/// <returns>um dataset do tipo pedido</returns>
		static public DataSet GetByID(OleDbConnection conn, OleDbTransaction tx, string table, string keyName, int[] keys, out ShopStatusEnum status)
		{
			DataSet ds = null;
			status = ShopStatusEnum.Ok;

			try
			{				
				//
				// criar objecto DataSet
				//
				ds = new DataSet();

				//
				// criar um Datadapter para executar o comando e devolver o dataset
				//
				System.Text.StringBuilder sb = new System.Text.StringBuilder("Select * From "+ table + " Where "+ keyName + " IN (");
				foreach (int k in keys)
				{
					sb.Append(k.ToString());
					sb.Append(",");
				}
				sb.Length = sb.Length-1;
				sb.Append(")");
				string sSqlCmd = sb.ToString();

				OleDbDataAdapter oAdapter = new OleDbDataAdapter(sSqlCmd, conn);
				oAdapter.SelectCommand.Transaction = tx;

				//
				// executar o comando e preencher um Dataset
				//
				oAdapter.Fill(ds, table);
			}
			catch(OleDbException ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO no mtodo 'UtilDB.GetByID': " + ex.Message);
				status = ShopStatusEnum.DatabaseError;
				ds = null;
			}

			return ds;
		}
		
		#endregion

		#region FindByStringField

		/// <summary>
		/// Obtem um dataset resultante de uma pesquisa por chave
		/// </summary>
		/// <param name="table">tabela a pesquisar</param>
		/// <param name="field">campo chave a usar</param>
		/// <param name="key">valor da chave a pesquisar</param>
		/// <returns>um dataset do tipo pedido</returns>
//		static public DataSet FindByStringField(string table, string field, string key, out ShopStatusEnum status)
//		{
//			OleDbConnection conn = null;
//			DataSet ret = new DataSet();
//			status = ShopStatusEnum.Ok;
//
//			try
//			{
//				//
//				// criar objecto de conexo  base de dados
//				//
//				conn = new OleDbConnection(UtilDB.CONN);
//
//				//
//				// invocar mtodo auxiliar
//				//
//				ret = FindByStringField(conn, table, field, key);
//			}
//			catch(OleDbException ex)
//			{
//				//
//				// tratar a excepo!!!!
//				//
//				System.Console.WriteLine("EXCEPO no componente 'UtilDB': " + ex.Message);
//				status = ShopStatusEnum.DatabaseError;
//			}
//			finally
//			{
//				//
//				// fechar a conexo
//				//
//				if (conn != null && conn.State != ConnectionState.Closed)
//					conn.Close();
//			}
//
//			//
//			// retornar valor
//			//
//			return ret;
//		}

		/// <summary>
		/// Obtem um dataset resultante de uma pesquisa por chave
		/// </summary>
		/// <param name="table">tabela a pesquisar</param>
		/// <param name="field">campo chave a usar</param>
		/// <param name="key">valor da chave a pesquisar</param>
		/// <returns>um dataset do tipo pedido</returns>
		static public DataSet FindByStringField(OleDbConnection conn, string table, string field, string key, out ShopStatusEnum status)
		{
			DataSet ret = new DataSet();
			status = ShopStatusEnum.Ok;

			try
			{
				//
				// criar um Datadapter para executar o comando e devolver o dataset
				//
				OleDbDataAdapter da = new OleDbDataAdapter("SELECT * FROM " + table + " WHERE " + field + " LIKE '" + key + "%'", conn);

				//
				// executar o comando e preencher um Dataset
				//
				da.Fill(ret, table);
			}
			catch(OleDbException ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO no componente 'UtilDB': " + ex.Message);
				status = ShopStatusEnum.DatabaseError;
			}

			//
			// retornar valor
			//
			return ret;
		}

		#endregion
		
		#region Mtodos privados

		/// <summary>
		/// Valida um login/password no sistema
		/// </summary>
		/// <param name="User">username de login na aplicao</param>
		/// <param name="Pass">password de login na aplicao</param>
		/// <returns></returns>
		static public ShopStatusEnum ValidateLogin(string user, string pass, bool isCustomer, out int userOrCustomerID)
		{
			ShopStatusEnum status = ShopStatusEnum.Ok;
			OleDbConnection conn = null;

			userOrCustomerID = -1;

			try
			{
				//
				// criar objecto de conexo  base de dados e abrir a conexo
				//
				conn = new OleDbConnection(CONN);
				conn.Open();

				//
				// invocar mtodo auxiliar
				//
				status = ValidateLogin(conn, null, user, pass, isCustomer, out userOrCustomerID);
			}
			catch(OleDbException ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO na validao do 'User': " + ex.Message);
				status = ShopStatusEnum.DatabaseError;
			}
			finally
			{
				//
				// fechar a conexo
				//
				if (conn.State == ConnectionState.Open)
					conn.Close();
			}

			return status;
		}
		
		/// <summary>
		/// Valida um login/password no sistema
		/// </summary>
		/// <param name="User">username de login na aplicao</param>
		/// <param name="Pass">password de login na aplicao</param>
		/// <param name="isCustomer">flag indicando se deve tentar validar este utilizador como cliente</param>
		/// <returns></returns>
		static public ShopStatusEnum ValidateLogin(OleDbConnection conn, OleDbTransaction tx, string user, string pass, bool isCustomer, out int userOrCustomerID)
		{
			ShopStatusEnum status = ShopStatusEnum.Ok;
			OleDbCommand cmd  = null;

			userOrCustomerID = -1;

			try
			{
				//
				// criar comando SQL a executar
				//
				if (isCustomer)
					cmd = new OleDbCommand("Select * from Customers Where User=? and Pass=?", conn);
				else
					cmd = new OleDbCommand("Select * from Users Where User=? and Pass=?", conn);
				cmd.Transaction = tx;
				cmd.Parameters.Add("@u", user);
				cmd.Parameters.Add("@p", pass);

				//
				// executar o comando e obter um DataReader
				// poderia ser feito usando um count(*) e um ExecuteScalar()
				//
				OleDbDataReader dr = cmd.ExecuteReader();

				//
				// verificar se retornou dados 
				// ( necessrio manter a conexo aberta pois estamos a usar um DataReader)
				//
				if (dr.HasRows)
				{
					status = ShopStatusEnum.Ok;

					dr.Read();
					userOrCustomerID = (int)dr[0]; // assume que 1 campo  o ID!!!!
				}
				else
					status = ShopStatusEnum.InvalidLogin;

				dr.Close();
			}
			catch(OleDbException ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO na validao do 'User': " + ex.Message);
				status = ShopStatusEnum.DatabaseError;
			}

			return status;
		}
		#endregion
	}
}
